package moe.oko.Kiafumi.command;

import moe.oko.Kiafumi.util.CommandInfo;
import moe.oko.Kiafumi.util.CommandType;
import moe.oko.Kiafumi.util.EmbedUI;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;

import java.time.LocalDate;
import java.time.Month;
import java.time.ZonedDateTime;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.List;

public class SeptemberDateCommand extends CommandClass {

    @Override
    public boolean isEnabled() { return true; }

    @Override
    public String getName() { return "SeptemberDate"; }

    @Override
    public void newCommand(String name, SlashCommandInteractionEvent e) {
        if ("sdate".equals(name)) {
            e.deferReply().queue();
            // Setup vars
            final var september = LocalDate.of(1993, Month.SEPTEMBER, 30);
            var now = LocalDate.now();

            // Create the Eternal September date
            var sdate = ChronoUnit.DAYS.between(september, now);

            EmbedBuilder eb = new EmbedBuilder()
                    .setColor(EmbedUI.INFO)
                    .setTitle("sdate")
                    .setDescription("Today is September, " + sdate + " 1993, the september that never ends")
                    .setFooter(EmbedUI.BRAND)
                    .setTimestamp(ZonedDateTime.now());
            e.getHook().sendMessageEmbeds(eb.build()).queue();
        }
    }

    @Override
    public List<CommandInfo> getSlashCommandInfo() {
        List<CommandInfo> cil = new ArrayList<>();
        CommandInfo ci = new CommandInfo("sdate", "Returns the Eternal September date.", CommandType.COMMAND);
        cil.add(ci);
        return cil;
    }
}
